commit 77da14136b689daefe37608b4fd77417cb8c17b3
Author: Simon Arlott <sa.me.uk>
Date:   Sun Jan 7 18:04:55 2024 +0000

    DKIM: signing with t but no x timestamp.  Bug 2851

diff --git a/src/src/dkim.c b/src/src/dkim.c
index 59025608f..63b16af39 100644
--- a/src/src/dkim.c
+++ b/src/src/dkim.c
@@ -720,8 +720,12 @@ if (dkim_domain)
       if (!(dkim_timestamps_expanded = expand_string(dkim->dkim_timestamps)))
 	{ errwhen = US"dkim_timestamps"; goto expand_bad; }
       else
-	xval = (tval = (unsigned long) time(NULL))
-	      + strtoul(CCS dkim_timestamps_expanded, NULL, 10);
+        {
+        tval = (unsigned long) time(NULL);
+        xval = strtoul(CCS dkim_timestamps_expanded, NULL, 10);
+        if (xval > 0)
+          xval += tval;
+        }
 
     if (!(sig = pdkim_init_sign(&dkim_sign_ctx, dkim_signing_domain,
 			  dkim_signing_selector,

